mod occlum_utils;
mod prelude;

pub use crate::occlum_utils::*;
pub use crate::prelude::*;

#[no_mangle]
pub extern "C" fn utils_ioctl_open() -> *mut c_void {
    if let Ok(fd) = UtilsIoctl::new() {
        Box::into_raw(Box::new(fd)) as *mut c_void
    } else {
        std::ptr::null_mut::<u8>() as *mut c_void
    }
}

#[no_mangle]
pub extern "C" fn utils_gen_key(
    handle: *mut c_void,
    key: *mut sgx_key_128bit_t,
    key_request: *const sgx_key_request_t,
) -> i32 {
    if handle.is_null() {
        return -1;
    }

    let ioctl_dev = unsafe { &mut *(handle as *mut UtilsIoctl) };

    let mut key_arg = IoctlGetKeyArg { key_request, key };

    ioctl_dev.generate_key(&mut key_arg).unwrap_or(-1)
}

#[no_mangle]
pub extern "C" fn utils_ioctl_close(handle: *mut c_void) {
    if handle.is_null() {
        return;
    }

    let ioctl_dev = unsafe { &mut *(handle as *mut UtilsIoctl) };

    ioctl_dev.close();
}
